
#include "png.h"

/* Standard (desktop!) colour palettes for files which don't provide a local palette */
/* In 1,2,4bpp modes, colour 0 is transparent.  For 8bpp, colour 1 is transparent and we move pixels 1 -> 0 */


/* 4bpp (16 colours) */
png_color colpal16[17]={{0,0,0},{255,255,255},{221,221,221},{187,187,187},{153,153,153},{119,119,119},
{85,85,85},{51,51,51},{0,0,0},{0,68,153},{238,238,0},{0,204,0},{221,0,0},{238,238,187},{85,136,0},{255,187,0},{0,187,255}};

/* 2bpp (4 colours) */
png_color colpal4[5]={{0,0,0},{0,0,0},{96,96,96},{192,192,192},{255,255,255}};

/* 1bpp (2 colours) */
png_color colpal2[3]={{0,0,0},{255,255,255},{0,0,0}};


/* RISC OS's standard 8bpp palette is somewhat bizarre, as it is
   based on odd DAC bits being fixed.  Here's an algorithm to generate it.  */
   
png_color riscos256colpal[256];

void makeriscos256colpal(void)
{
    unsigned int i, r, g, b;
    
    for (i=0; i<256; i++)
    {
        r=g=b=0;
        
        if (i & 128) b|=8;
        if (i &  64) g|=8;
        if (i &  32) g|=4;
        if (i &  16) r|=8;
        if (i &   8) b|=4;
        if (i &   4) r|=4;
        if (i &   2) { r|=2; g|=2; b|=2; }
        if (i &   1) { r|=1; g|=1; b|=1; }
        
        riscos256colpal[i].red   = r|(r<<4);
        riscos256colpal[i].green = g|(g<<4);
        riscos256colpal[i].blue  = b|(b<<4);
    }
}
